/*
 * FieldPanel.java
 *
 * Created on May 6, 2011, 6:37:14 PM
 */

/**
 *
 * @author Paolo Forni
 */
import java.awt.*;
import java.awt.geom.Line2D;

public class FieldPanel extends javax.swing.JPanel implements Runnable {
	private Accelerometer accelerometer;
    private Thread thread;
    private double x_x1,x_x2,y_x1,y_x2;
    private int ax,ay;
    private final double T,b,m,lambda,a_scale,y_scale,x_OFFSET,y_OFFSET;
    private int ball;

    /** Creates new form FieldPanel */
    public FieldPanel() {
    	accelerometer = new Accelerometer();
    	accelerometer.initialize();
		x_x1=x_x2=y_x1=y_x2=0;
		ax=ay=0;
		b=3;
		m=10;
		T=0.06;
        ball = 15;
        y_scale=16;
        a_scale=1;
        
        
        lambda = Math.exp(-b/m*T);
        y_OFFSET = 400;
        x_OFFSET = 350;
        setOpaque(true);
        setBackground(Color.black);
    }

    public void start() {
        if(thread==null) {
            thread = new Thread(this);
            thread.start();
        }
    }

//335 per y e 342 per x
    public void run() {
        while(true) {
			if(accelerometer.state==0) continue;
			ax=accelerometer.x;
			ay=accelerometer.y;
			repaint();
			try {
				Thread.sleep((int)T*1000);
			} catch(InterruptedException e) {
			}
            
        }
        
    }
    
    private int getYposition() {
		double temp1=x_x2;
		double temp2=-lambda*x_x1+(1+lambda)*x_x2+(ax-342)/a_scale;
		double temp_y = (m-m*lambda)*(x_x1-x_x2)/(y_scale*b*b)+T*(lambda*x_x1+x_x2)/(y_scale*b)  +x_OFFSET;
		x_x1=temp1;
		x_x2=temp2;
		return (int)temp_y;
	}
	
	private int getXposition() {
		double temp1=y_x2;
		double temp2=-lambda*y_x1+(1+lambda)*y_x2+(ay-335)/a_scale;
		double temp_y = (m-m*lambda)*(y_x1-y_x2)/(y_scale*b*b)+T*(lambda*y_x1+y_x2)/(y_scale*b)  +y_OFFSET;
		y_x1=temp1;
		y_x2=temp2;
		return (int)temp_y;
		
	}

    public void paint(Graphics g) {
		Graphics2D g2 = (Graphics2D)g;
		RenderingHints rh = new RenderingHints(
			RenderingHints.KEY_ANTIALIASING,
			RenderingHints.VALUE_ANTIALIAS_ON);
		g2.setRenderingHints(rh);
		g2.setColor(Color.black);
		g2.clearRect(0,0,getWidth(),getHeight());
        g2.fillOval(getXposition()-ball,getYposition()-ball,2*ball,2*ball);
        g2.fill(new Rectangle(600,520,180,160));
        g2.fill(new Rectangle(20,520,180,160));
        g2.setColor(Color.WHITE);
        double dx = 270*(double)(ax-342)/342;
        g2.draw(new Line2D.Double(600,600-dx,780,600+dx));
        double dy = 270*(double)(ay-335)/335;
        g2.draw(new Line2D.Double(20,600-dy,200,600+dy));
        g2.drawString("front view",130,536);
        g2.drawString("side view",710,536);

    }
}
